Orxonox: OIS::LinuxInputManager Class Reference

# OIS::LinuxInputManager Class Reference

`#include <src/ois/linux/LinuxInputManager.h>`

Inheritance diagram for OIS::LinuxInputManager:

List of all members.

## Public Member Functions

bool | _getGrabState ()
Window | _getWindow ()
| Method for retrieving the XWindow Handle.
void | _initialize (ParamList &paramList)
void | _setGrabState (bool grab)
| Internal method for checking if regrabbing is needed.
void | _setKeyboardUsed (bool used)
| Internal method, used for flaggin keyboard as available/unavailable for creation.
void | _setMouseUsed (bool used)
| Internal method, used for flaggin mouse as available/unavailable for creation.
Object * | createObject (InputManager *creator, Type iType, bool bufferMode, const std::string &vendor="")
void | destroyObject (Object *obj)
DeviceList | freeDeviceList ()
int | freeDevices (Type iType)
| LinuxInputManager ()
int | totalDevices (Type iType)
bool | vendorExist (Type iType, const std::string &vendor)
virtual | ~LinuxInputManager ()

## Protected Member Functions

void | _enumerateDevices ()
| internal class method for finding attached devices
void | _parseConfigSettings (ParamList &paramList)
| internal class method for dealing with param list

## Protected Attributes

bool | grabKeyboard
bool | grabMouse
| Keyboard, Mouse Settings.
bool | hideMouse
char | joySticks
| Number of joysticks found.
bool | keyboardUsed
| Used to know if we used up keyboard.
bool | mGrabs
bool | mouseUsed
| Used to know if we used up mouse.
JoyStickInfoList | unusedJoyStickList
| List of unused joysticks ready to be used.
bool | useXRepeat
| By default, keyboard disables XRepeatRate.
Window | window
| X11 Stuff.

## Detailed Description

Linux X11 InputManager specialization - Using lowlevel joys

## Constructor & Destructor Documentation

LinuxInputManager::LinuxInputManager | ( |  | ) |

References grabKeyboard, grabMouse, hideMouse, keyboardUsed, OIS::InputManager::mFactories, mGrabs, mouseUsed, useXRepeat, and window.

LinuxInputManager::~LinuxInputManager | ( |  | ) | `[virtual]`

References OIS::LinuxJoyStick::_clearJoys(), and unusedJoyStickList.

## Member Function Documentation

void LinuxInputManager::_enumerateDevices | ( |  | ) | `[protected]`

internal class method for finding attached devices

References OIS::LinuxJoyStick::_scanJoys(), joySticks, and unusedJoyStickList.

Referenced by _initialize().

bool OIS::LinuxInputManager::_getGrabState | ( |  | ) | `[inline]`

References mGrabs.

Referenced by OIS::LinuxKeyboard::capture().

Window OIS::LinuxInputManager::_getWindow | ( |  | ) | `[inline]`

Method for retrieving the XWindow Handle.

References window.

void LinuxInputManager::_initialize | ( | ParamList & | paramList | ) | `[virtual]`

Remarks:
  Called from createInputSystem, gives derived input class a chance to setup after it is created

Implements OIS::InputManager.

References _enumerateDevices(), and _parseConfigSettings().

void LinuxInputManager::_parseConfigSettings | ( | ParamList & | paramList | ) | `[protected]`

internal class method for dealing with param list

References OIS::E_InvalidParam, grabKeyboard, grabMouse, hideMouse, OIS_EXCEPT, useXRepeat, and window.

Referenced by _initialize().

void OIS::LinuxInputManager::_setGrabState | ( | bool | grab | ) | `[inline]`

Internal method for checking if regrabbing is needed.

References mGrabs.

Referenced by OIS::LinuxKeyboard::capture().

void OIS::LinuxInputManager::_setKeyboardUsed | ( | bool | used | ) | `[inline]`

Internal method, used for flaggin keyboard as available/unavailable for creation.

References keyboardUsed.

void OIS::LinuxInputManager::_setMouseUsed | ( | bool | used | ) | `[inline]`

Internal method, used for flaggin mouse as available/unavailable for creation.

References mouseUsed.

Object * LinuxInputManager::createObject | ( | InputManager * | creator,
|  | Type | iType,
|  | bool | bufferMode,
|  | const std::string & | vendor = `""` |
| ) |  |  | `[virtual]`

Remarks:
  Creates the object

Parameters:

  | iType | Type to create
  | bufferMode | True to setup for buffered events
  | vendor | Create a device with the vendor name, "" means vendor name is unimportant

Implements OIS::FactoryCreator.

References OIS::E_InputDeviceNonExistant, grabKeyboard, grabMouse, hideMouse, keyboardUsed, mouseUsed, OIS_EXCEPT, OIS::OISJoyStick, OIS::OISKeyboard, OIS::OISMouse, unusedJoyStickList, and useXRepeat.

void LinuxInputManager::destroyObject | ( | Object * | obj | ) | `[virtual]`

Remarks:
  Destroys object

Parameters:

  | obj | Object to destroy

Implements OIS::FactoryCreator.

References OIS::OISJoyStick, OIS::Object::type(), and unusedJoyStickList.

DeviceList LinuxInputManager::freeDeviceList | ( |  | ) | `[virtual]`

Implements OIS::FactoryCreator.

References keyboardUsed, OIS::InputManager::mInputSystemName, mouseUsed, OIS::OISJoyStick, OIS::OISKeyboard, OIS::OISMouse, and unusedJoyStickList.

int LinuxInputManager::freeDevices | ( | Type | iType | ) | `[virtual]`

Remarks:
  Number of free devices of requested type

Parameters:

  | iType | Type of devices to check

Implements OIS::FactoryCreator.

References keyboardUsed, mouseUsed, OIS::OISJoyStick, OIS::OISKeyboard, OIS::OISMouse, and unusedJoyStickList.

int LinuxInputManager::totalDevices | ( | Type | iType | ) | `[virtual]`

Remarks:
  Number of total devices of requested type

Parameters:

  | iType | Type of devices to check

Implements OIS::FactoryCreator.

References joySticks, OIS::OISJoyStick, OIS::OISKeyboard, and OIS::OISMouse.

bool LinuxInputManager::vendorExist | ( | Type | iType,
|  | const std::string & | vendor |
| ) |  |  | `[virtual]`

Remarks:
  Does a Type exist with the given vendor name

Parameters:

  | iType | Type to check
  | vendor | Vendor name to test

Implements OIS::FactoryCreator.

References OIS::InputManager::mInputSystemName, OIS::OISJoyStick, OIS::OISKeyboard, OIS::OISMouse, and unusedJoyStickList.

## Member Data Documentation

bool OIS::LinuxInputManager::grabKeyboard`[protected]`

Referenced by _parseConfigSettings(), createObject(), and LinuxInputManager().

bool OIS::LinuxInputManager::grabMouse`[protected]`

Keyboard, Mouse Settings.

Referenced by _parseConfigSettings(), createObject(), and LinuxInputManager().

bool OIS::LinuxInputManager::hideMouse`[protected]`

Referenced by _parseConfigSettings(), createObject(), and LinuxInputManager().

char OIS::LinuxInputManager::joySticks`[protected]`

Number of joysticks found.

Referenced by _enumerateDevices(), and totalDevices().

bool OIS::LinuxInputManager::keyboardUsed`[protected]`

Used to know if we used up keyboard.

Referenced by _setKeyboardUsed(), createObject(), freeDeviceList(), freeDevices(), and LinuxInputManager().

bool OIS::LinuxInputManager::mGrabs`[protected]`

Referenced by _getGrabState(), _setGrabState(), and LinuxInputManager().

bool OIS::LinuxInputManager::mouseUsed`[protected]`

Used to know if we used up mouse.

Referenced by _setMouseUsed(), createObject(), freeDeviceList(), freeDevices(), and LinuxInputManager().

JoyStickInfoList OIS::LinuxInputManager::unusedJoyStickList`[protected]`

List of unused joysticks ready to be used.

Referenced by _enumerateDevices(), createObject(), destroyObject(), freeDeviceList(), freeDevices(), vendorExist(), and ~LinuxInputManager().

bool OIS::LinuxInputManager::useXRepeat`[protected]`

By default, keyboard disables XRepeatRate.

Referenced by _parseConfigSettings(), createObject(), and LinuxInputManager().

Window OIS::LinuxInputManager::window`[protected]`

X11 Stuff.

Referenced by _getWindow(), _parseConfigSettings(), and LinuxInputManager().

The documentation for this class was generated from the following files:

- src/ois/linux/LinuxInputManager.h
- src/ois/linux/LinuxInputManager.cpp